{: This is an example for t_TypedObjectList.tpl. It declares a TMemoList
   class which can be used to store objects of type TMemo in a typesafe
   manner. For example, if you want to access a particular memo stored
   in the list, you can just reference it without typecasting:
   SomeMemoList[0].Lines.Text := 'new text';
   Please note that the list owns the memos, so if the list is freed it will
   also free all memos! }
unit u_MemoList;

interface

uses
  Sysutils,
  Classes,
  Contnrs,
{$ifdef mswindows}
  StdCtrls;
{$endif}
{$ifdef linux}
  QStdCtrls;
{$endif}

{$define TYPED_OBJECT_LIST_TEMPLATE}
// this defines what is stored in the list
type
  _TYPED_OBJECT_LIST_ITEM_ = TMemo;
// include the template's interface part
{$INCLUDE 't_TypedObjectList.tpl'}

// this declares TMemoList to be based on the template _TYPED_OBJECT_LIST_
type
  TMemoList = class(_TYPED_OBJECT_LIST_)
    // you can declare additional properties an methods here
  end;

implementation

// include the template's interface part
{$INCLUDE 't_TypedObjectList.tpl'}

// implement any additional methods here

end.
